/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
)

// checks if the WhatsAppTemplateComponentExample type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &WhatsAppTemplateComponentExample{}

// WhatsAppTemplateComponentExample struct for WhatsAppTemplateComponentExample
type WhatsAppTemplateComponentExample struct {
	HeaderText []string `json:"header_text,omitempty"`
	BodyText []string `json:"body_text,omitempty"`
	FooterText []string `json:"footer_text,omitempty"`
	HeaderUrl []string `json:"header_url,omitempty"`
	HeaderHandle []string `json:"header_handle,omitempty"`
}

// NewWhatsAppTemplateComponentExample instantiates a new WhatsAppTemplateComponentExample object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewWhatsAppTemplateComponentExample() *WhatsAppTemplateComponentExample {
	this := WhatsAppTemplateComponentExample{}
	return &this
}

// NewWhatsAppTemplateComponentExampleWithDefaults instantiates a new WhatsAppTemplateComponentExample object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewWhatsAppTemplateComponentExampleWithDefaults() *WhatsAppTemplateComponentExample {
	this := WhatsAppTemplateComponentExample{}
	return &this
}

// GetHeaderText returns the HeaderText field value if set, zero value otherwise.
func (o *WhatsAppTemplateComponentExample) GetHeaderText() []string {
	if o == nil || IsNil(o.HeaderText) {
		var ret []string
		return ret
	}
	return o.HeaderText
}

// GetHeaderTextOk returns a tuple with the HeaderText field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WhatsAppTemplateComponentExample) GetHeaderTextOk() ([]string, bool) {
	if o == nil || IsNil(o.HeaderText) {
		return nil, false
	}
	return o.HeaderText, true
}

// HasHeaderText returns a boolean if a field has been set.
func (o *WhatsAppTemplateComponentExample) HasHeaderText() bool {
	if o != nil && !IsNil(o.HeaderText) {
		return true
	}

	return false
}

// SetHeaderText gets a reference to the given []string and assigns it to the HeaderText field.
func (o *WhatsAppTemplateComponentExample) SetHeaderText(v []string) {
	o.HeaderText = v
}

// GetBodyText returns the BodyText field value if set, zero value otherwise.
func (o *WhatsAppTemplateComponentExample) GetBodyText() []string {
	if o == nil || IsNil(o.BodyText) {
		var ret []string
		return ret
	}
	return o.BodyText
}

// GetBodyTextOk returns a tuple with the BodyText field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WhatsAppTemplateComponentExample) GetBodyTextOk() ([]string, bool) {
	if o == nil || IsNil(o.BodyText) {
		return nil, false
	}
	return o.BodyText, true
}

// HasBodyText returns a boolean if a field has been set.
func (o *WhatsAppTemplateComponentExample) HasBodyText() bool {
	if o != nil && !IsNil(o.BodyText) {
		return true
	}

	return false
}

// SetBodyText gets a reference to the given []string and assigns it to the BodyText field.
func (o *WhatsAppTemplateComponentExample) SetBodyText(v []string) {
	o.BodyText = v
}

// GetFooterText returns the FooterText field value if set, zero value otherwise.
func (o *WhatsAppTemplateComponentExample) GetFooterText() []string {
	if o == nil || IsNil(o.FooterText) {
		var ret []string
		return ret
	}
	return o.FooterText
}

// GetFooterTextOk returns a tuple with the FooterText field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WhatsAppTemplateComponentExample) GetFooterTextOk() ([]string, bool) {
	if o == nil || IsNil(o.FooterText) {
		return nil, false
	}
	return o.FooterText, true
}

// HasFooterText returns a boolean if a field has been set.
func (o *WhatsAppTemplateComponentExample) HasFooterText() bool {
	if o != nil && !IsNil(o.FooterText) {
		return true
	}

	return false
}

// SetFooterText gets a reference to the given []string and assigns it to the FooterText field.
func (o *WhatsAppTemplateComponentExample) SetFooterText(v []string) {
	o.FooterText = v
}

// GetHeaderUrl returns the HeaderUrl field value if set, zero value otherwise.
func (o *WhatsAppTemplateComponentExample) GetHeaderUrl() []string {
	if o == nil || IsNil(o.HeaderUrl) {
		var ret []string
		return ret
	}
	return o.HeaderUrl
}

// GetHeaderUrlOk returns a tuple with the HeaderUrl field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WhatsAppTemplateComponentExample) GetHeaderUrlOk() ([]string, bool) {
	if o == nil || IsNil(o.HeaderUrl) {
		return nil, false
	}
	return o.HeaderUrl, true
}

// HasHeaderUrl returns a boolean if a field has been set.
func (o *WhatsAppTemplateComponentExample) HasHeaderUrl() bool {
	if o != nil && !IsNil(o.HeaderUrl) {
		return true
	}

	return false
}

// SetHeaderUrl gets a reference to the given []string and assigns it to the HeaderUrl field.
func (o *WhatsAppTemplateComponentExample) SetHeaderUrl(v []string) {
	o.HeaderUrl = v
}

// GetHeaderHandle returns the HeaderHandle field value if set, zero value otherwise.
func (o *WhatsAppTemplateComponentExample) GetHeaderHandle() []string {
	if o == nil || IsNil(o.HeaderHandle) {
		var ret []string
		return ret
	}
	return o.HeaderHandle
}

// GetHeaderHandleOk returns a tuple with the HeaderHandle field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WhatsAppTemplateComponentExample) GetHeaderHandleOk() ([]string, bool) {
	if o == nil || IsNil(o.HeaderHandle) {
		return nil, false
	}
	return o.HeaderHandle, true
}

// HasHeaderHandle returns a boolean if a field has been set.
func (o *WhatsAppTemplateComponentExample) HasHeaderHandle() bool {
	if o != nil && !IsNil(o.HeaderHandle) {
		return true
	}

	return false
}

// SetHeaderHandle gets a reference to the given []string and assigns it to the HeaderHandle field.
func (o *WhatsAppTemplateComponentExample) SetHeaderHandle(v []string) {
	o.HeaderHandle = v
}

func (o WhatsAppTemplateComponentExample) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o WhatsAppTemplateComponentExample) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.HeaderText) {
		toSerialize["header_text"] = o.HeaderText
	}
	if !IsNil(o.BodyText) {
		toSerialize["body_text"] = o.BodyText
	}
	if !IsNil(o.FooterText) {
		toSerialize["footer_text"] = o.FooterText
	}
	if !IsNil(o.HeaderUrl) {
		toSerialize["header_url"] = o.HeaderUrl
	}
	if !IsNil(o.HeaderHandle) {
		toSerialize["header_handle"] = o.HeaderHandle
	}
	return toSerialize, nil
}

type NullableWhatsAppTemplateComponentExample struct {
	value *WhatsAppTemplateComponentExample
	isSet bool
}

func (v NullableWhatsAppTemplateComponentExample) Get() *WhatsAppTemplateComponentExample {
	return v.value
}

func (v *NullableWhatsAppTemplateComponentExample) Set(val *WhatsAppTemplateComponentExample) {
	v.value = val
	v.isSet = true
}

func (v NullableWhatsAppTemplateComponentExample) IsSet() bool {
	return v.isSet
}

func (v *NullableWhatsAppTemplateComponentExample) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableWhatsAppTemplateComponentExample(val *WhatsAppTemplateComponentExample) *NullableWhatsAppTemplateComponentExample {
	return &NullableWhatsAppTemplateComponentExample{value: val, isSet: true}
}

func (v NullableWhatsAppTemplateComponentExample) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableWhatsAppTemplateComponentExample) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


